#include <iostream>
#include <cmath>

using namespace std;

struct pacijent
{
	string krgr;
	int potrebno;

	int datoo=0;
	int datoa=0;
	int datob=0;
	int datoab=0;
};

int main()
{
	int n;
	int o,a,b,ab;
	bool moguce = true;
	
	cin >> n;
	cin >> o >> a >> b >> ab;
	pacijent pac[n];

	for(int i=0;i<n;i++)
	{
		cin >> pac[i].krgr >> pac[i].potrebno;		
	}
	

	for(int i=0;i<n;i++)
	{
		if(pac[i].krgr == "O")
		{
			if(pac[i].potrebno>pac[i].datoo)
			{
				if(o >= pac[i].potrebno)
				{
					o -= pac[i].potrebno;
					pac[i].datoo = pac[i].potrebno; 	
				}
				else
				{
					moguce = false;
				}
			}
		}
	}

	
	for(int i=0;i<n;i++)
	{
		if(pac[i].krgr == "A")
		{
			if(pac[i].potrebno>pac[i].datoo+pac[i].datoa)
			{
				if(a+o >= pac[i].potrebno)
				{
					pac[i].datoa = min(a,pac[i].potrebno);
					a -= pac[i].datoa;

					if(!(pac[i].datoo+pac[i].datoa == pac[i].potrebno))
					{
						pac[i].datoo = pac[i].potrebno - pac[i].datoa;
						o-=pac[i].datoo;
					}
				}
				else
				{
					moguce = false;
				}
			}
		}
	}


	for(int i=0;i<n;i++)
	{
		if(pac[i].krgr == "B")
		{
			if(pac[i].potrebno>pac[i].datoo+pac[i].datob)
			{
				if(b+o >= pac[i].potrebno)
				{
					pac[i].datob = min(b,pac[i].potrebno);
					b -= pac[i].datob;

					if(!(pac[i].datob == pac[i].potrebno))
					{
						pac[i].datoo = pac[i].potrebno - pac[i].datob;
						o-=pac[i].datoo;
					}
				}
				else
				{
					moguce = false;
				}
			}
		}
	}

	
	for(int i=0;i<n;i++)
	{
		if(pac[i].krgr == "AB")
		{
			if(pac[i].potrebno>pac[i].datoo+pac[i].datoa)
			{
				if(a+b+o+ab >= pac[i].potrebno)
				{
					pac[i].datoa = min(a,pac[i].potrebno);
					a -= pac[i].datoa;

					if(!(pac[i].datoa == pac[i].potrebno))
					{
						pac[i].datob = min(b,pac[i].potrebno - pac[i].datoa);
						b-=pac[i].datob;
					}
					
					if(!(pac[i].datoa+pac[i].datob == pac[i].potrebno))
					{
						pac[i].datoo = min(o,pac[i].potrebno - pac[i].datoa - pac[i].datob);
						o-=pac[i].datoo;
					}


					if(!(pac[i].datoa+pac[i].datob+pac[i].datoo == pac[i].potrebno))
					{
						pac[i].datoab = min(ab,pac[i].potrebno - pac[i].datoa - pac[i].datob - pac[i].datoo);
						ab-=pac[i].datoab;
					}
				}
				else
				{
					moguce = false;
				}
			}
		}
	}

	if(moguce)
	{
		cout << "moguce" << endl;
		for(int i=0;i<n;i++)
		{
			cout << pac[i].datoo << " " << pac[i].datoa << " "  << pac[i].datob << " " << pac[i].datoab << endl;
		}
	}
	else
	{
		cout << "nemoguce";
	}

	return 0;
}